#ifndef IPCEVENT__H
#define IPCEVENT__H

typedef size_t ipc_size_t;
typedef int ipc_bool_t;

typedef struct ipc_event_sink_t *ipc_event_sink_t;

typedef struct ipc_event_t *ipc_event_t;

typedef void (*ipc_event_handler_t)(ipc_event_t event, ipc_bool_t want_reply);

typedef enum { IPC_SEND, IPC_REPLY, IPC_ACK } ipc_event_type_t;

int IPC_StartServer(char *progpath, char *argv[],
		    ipc_event_sink_t *psink, ipc_event_handler_t handler);
int IPC_InitServer(ipc_event_sink_t *psink, ipc_event_handler_t handler);

int IPC_Disconnect(ipc_event_sink_t sink);

int IPC_SinkFD(ipc_event_sink_t sink, int *pfd);

int IPC_CreateEvent(ipc_event_t *pevent);
int IPC_DisposeEvent(ipc_event_t event);

int IPC_PutEventData(ipc_event_t event, void *data, ipc_size_t size);
int IPC_AppendEventData(ipc_event_t event, void *data, ipc_size_t size);
int IPC_GetEventData(ipc_event_t event, void **pdata, ipc_size_t *psize);

int IPC_SendEvent(ipc_event_sink_t sink, ipc_event_t event, ipc_bool_t wait);

int IPC_HandleEvent(ipc_event_sink_t sink);

#endif /* IPCEVENT__H */
